#ifndef CPKGREMOVER_H
#define CPKGREMOVER_H

#include <iostream>

// This class provides an easy way to remove a package.
// See COPYING for license information.

class CPkgRemover
{
public:
	CPkgRemover(std::string file);
	~CPkgRemover();
	float Iteration();
protected:
	std::string	_File;
};

CPkgRemover::CPkgRemover(std::string file) :
_File(file.substr(file.rfind('/') + 1))
{
	WRITELOG("Removing package: " + _File);
	std::string	_cmd = "rm -f " + TMPFILE(_File + ".done");
	system(_cmd.c_str());
	_cmd = "/sbin/removepkg " + file + " > /dev/null && touch " + TMPFILE(_File + ".done") + " &";
	system(_cmd.c_str());
}

CPkgRemover::~CPkgRemover()
{
	std::string	_cmd = "rm -f " + TMPFILE(_File + ".done");
	system(_cmd.c_str());
}

float CPkgRemover::Iteration()
{	// Call this periodically to determine the progress of removal.
	float		_status = 0.0f;
	std::ifstream	_if;
	_if.open(TMPFILE(_File + ".done").c_str(), std::ios_base::in);
	if ( _if.is_open() ) {
		WRITELOG("Finished removing: " + _File);
		_status = 2.0f;
	}
	_if.close();
	return _status;
}

#endif
